/* 
* Copyright (C) 2015, Adrian Jarabo (http://giga.cps.unizar.es/~ajarabo/)
*
* Permission is hereby granted, free of charge, to any person obtaining
* a copy of this software and associated documentation files (the "Software"),
* to deal in the Software without restriction, including without limitation
* the rights to use, copy, modify, merge, publish, distribute, sublicense,
* and/or sell copies of the Software, and to permit persons to whom
* the Software is furnished to do so, subject to the following conditions:

* The above copyright notice and this permission notice shall be included
* in all copies or substantial portions of the Software.

* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
* EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
* MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
* IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
* DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
* TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE
* OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/

#ifndef _RANDOM_NUMBERS_H_
#define _RANDOM_NUMBERS_H_
//#include <random>
namespace RNG
{
	/**	Random Number Generator based
		on the (poor) rand() function.
		This is a statistically poor RNG, so 
		it is not recomended at all.
	*/
	class StdRandom
	{
	public:
		StdRandom()
		{}
		static Real get_real()
		{
			//return .5;
			/*static std::mt19937 generator(time(NULL));
			static std::uniform_real_distribution<float> uniform(0.0f,1.0f);
			Real rnd = uniform(generator);*/
			Real rnd = static_cast<Real>(rand())/static_cast<Real>(RAND_MAX);
			while (rnd >= 1.0f)
				rnd = static_cast<Real>(rand())/static_cast<Real>(RAND_MAX);
			
			return rnd;
		}
	}; //StdRandom

	typedef StdRandom Random;
}; //RNG
#endif